#ifndef INC_GTCYCLE_H
#define INC_GTCYCLE_H

#include "gtcascade.h"

/************************************************************************\
*
* GtCycle class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtMenu;
class GtLabel;

/* Type of cycle callback data */
typedef struct GtCycleCD
{
	ulong nr;
} GtCycleCD;

class GtCycle : public GtCascade
{
public:
		/* Standard */
	GtCycle(void);
	void Destroy(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtCycle"); }
	sbool IsSubClassOf(char *cn);
		/* Notify */
	void NotifyA(ulong tag,void *arg);
protected:
		/* Internal methods */
	sbool Mouse(XEvent *xe);
private:
	static int Cycle(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
protected:
		/* Instance variables */
	GtMenu *cmenu;
	GtLabel **clabs;
	GtLabel *clab;
	char **cnames;
	ulong cmax,cval;
};

extern GtCycle *GtMkCycle(char *n,GtManager *p,GtTag *tgs);
extern GtCycle *GtMkCycle(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTCYCLE_H */
