#ifndef INC_GTMENU_H
#define INC_GTMENU_H

#include "gtpopup.h"

/************************************************************************\
*
* GtMenu class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/


class GtMenu : public GtPopup
{
public:
		/* Standard */
	GtMenu(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	char *GetClass(void) { return("GtMenu"); }
	sbool IsSubClassOf(char *cn);
		/* Window management */
	sbool Build(void);
		/* Events */
	int Handle(XEvent *xe);
		/* Values */
	void SetEMask(ulong em);
		/* Notify */
	void NotifyA(ulong tag,void *arg);
		/* Menu / Popdown */
	void Popup(GtWidget *from,ulong button,Time tm);
	void Popup(ulong button,Time tm);
	void Popdown(void);
	void PopupSub(GtWidget *from,GtMenu *menu,Time tm);
	void PopdownSub(Time tm);
protected:
		/* Internal methods */
	sbool Mouse(XEvent *xe);
protected:
		/* Instance variables */
	GtWidget *frm;
	GtMenu *sub;
	ulong but;
	word sxp,syp,sxs,sys;
};

extern GtMenu *GtMkMenu(char *n,GtManager *p,GtTag *tgs);
extern GtMenu *GtMkMenu(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTMENU_H */
